/*  Image.h  */

#ifndef IMAGEN_H
#define IMAGEN_H

#include <fftw3.h>
#include <math.h>

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>

#include "io_tiff.h"
using namespace std;
#define MINDOUBLE 1.0e-2

inline double max(double a, double b)
{
  if(a<=b)
    return(b);
  else
    return(a);
};


inline double min(double a, double b)
{
  if(a>=b)
    return(b);
  else
    return(a);
};


class Image
{
 public:
  int dim[2];
  double * data;
  Image();
  Image(int row, int col);
  Image(int row, int col, double val);
  Image(Image  & im2);
  ~Image();
  void initialize(int rows, int col);
  void  operator*=(double dt);
  void  operator*=(Image & im2);
  void  operator=(Image & im2);
  void operator+=(Image & im2);
  void operator+=(double dt);
  int rows(){return dim[0];}
  int cols(){return dim[1];} 
  inline double & operator()(int i, int j)
    {
      return(data[i*dim[1]+j]);
    };
    
  double maxval();
  double maxabsval();
  double minval();
  double meanvalue();

  void threshold(double m,double M);
  void rescale(double minv, double maxv);

  void fftshift();
  double Dist(Image & Im2);
    
  void gaussian_kernel(int row, int col, double sigma);
  void linear_kernel(double alpha);
};


#endif

